//----------------------------------------------------------------------------
//     GT-511Cx.     
//----------------------------------------------------------------------------

#include "hardware.h"  //      
#include "lcd.h" //      
#include "knop.h" //      
#include "uart.h" //      UART
#include "GT511.h" //       GT-511Cx GT-511Cx
#include "i2c.h" //     
#include "24LC64.h" //     
#include "wdt.h" //     

//    
volatile unsigned int rejim_ustr = 0;  //     
volatile unsigned int podrejim_mast = 0;  //   -
volatile unsigned int rejim_glubina = 0;    //     

//    
static unsigned int level_out = level_out_AKT_H;  //      
                                       //   0 (level_out_AKT_L) -   , 0 (level_out_AKT_H) -     
static unsigned int interval_out = interval_out_MIN;  //  ,       
                                                    //    
                                                    //        
static unsigned int  ID_dostup = 0;     //      
static unsigned int  count_interval_out = 0; //        

static unsigned int ID_GT511 = 0;  //  ,         

//      
volatile extern unsigned int flagn_kn0, flagn_kn1, flagn_kn2; //   

//        GT-511Cx 
volatile unsigned int tx_Command = 0;       //       
volatile unsigned int rx_ACK_Command = 0;   //          
volatile unsigned int rx_ACK_Command_ERR = 0;  //          

extern unsigned char Command_Packet[SB_OEM_PKT_SIZE] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};   
                                        // ,  ,     
extern unsigned char ACK_Packet[];       // ,    ,    
   
//         
volatile unsigned int zwuk_H_ON = 0;  //     
volatile unsigned int zwuk_L_ON = 0;  //     

volatile unsigned int pred_dlit_H = 0;  //      
volatile unsigned int pred_dlit_L = 0;  //      

//      UART
volatile extern unsigned char rx0_byte; //   UART0
volatile extern unsigned char rx1_byte; //   UART1

volatile extern unsigned int rx0_byte_f; //    UART0
volatile extern unsigned int rx1_byte_f; //    UART1

//        I2C  24LC64 
unsigned int I2C_data = 0; //     24LC64
unsigned int I2C_addr = 0;  //  24LC64
unsigned int I2Crd_byte = 0; // ,   24LC64
volatile extern unsigned int I2C_addres;  //  24LC64
volatile extern unsigned int I2Cwr_byte; //     24LC64
volatile extern unsigned int wr_rd;  // / 24LC64
volatile extern unsigned int end_rd;  //   24LC64
volatile extern unsigned int end_wr;  //   24LC64
static unsigned int I2C_ON = 0;  //        I2C 
                                 //       

//    
static unsigned int i = 0;            //  
static unsigned int tempor = 0;      //   

unsigned int r100=0;    //------------------------------------------------------------------------ 
unsigned int r10=0;     //        
unsigned int r1=0;      //------------------------------------------------------------------------

//  ,         (  LCD  .)      
//-------------------------------------------------------------------------------------------------
void LCD_start_zastavka(); //        
void LCD_ishod_zastavka(); //     ()    
void LCD_palez_ne_prilogen();   //           
void LCD_oschibka();        //         
void LCD_GT511C();   //          "GT-511"  
void LCD_idet_analiz();  //          
void LCD_I2C_OK(unsigned int); //            I2C  
void LCD_I2C(unsigned int); //       I2C    
void LCD_dostup_otkr();  //            
void LCD_otkaz_w_dostupe();  //           
void LCD_master_rejim();  //       -  
void LCD_Akt_ur(unsigned int);  //             
void LCD_Interv(unsigned int); //             
void LCD_GetEnrollCount(unsigned int);  //       -       
void LCD_CheckEnrolled(unsigned int); //      ,      ID     
void LCD_Super_master(unsigned int);  //        --
void LCD_kursor_menu_master_rejim();  //       -   
void LCD_Zn_Akt_ur(unsigned int); //               
void LCD_super_master_rejim();  //         --  
void LCD_Zapros(); //      -       
void LCD_ID_ravno();  //       ,          
void LCD_Palez();  //        --   

//----------------------------------------------------------------------------
//                               
//----------------------------------------------------------------------------
void main(void)
{
  CPUinit();             // 
  __disable_interrupt(); // 
  INTERRUPTSinit();      // 
  TIMER0initstart();     // 0
  I2Cinit();             //  I2C
  __enable_interrupt();  // 

  
  //---------------------------------------------------------------------
  rejim_ustr = REG_ISH;  //     
  rejim_glubina = 0;    //   (0)     
  //---------------------------------------------------------------------  
  
  delay(tik_s5);   //   0,5 
  
  lcd_init();           //   
  lcd_clear();          //    

//,    ----------------------------------------------
  for ( i = 0 ; i < 9 ; i++ )	//     
    {
    lcd_pro_data(polno, 0 + i);
    
    pred_dlit_H = 50;  //          
    zwuk_H_ON = 1;  //          
    
    delay(tik_s1);   //   0,1 
    } 
//---------------------------------------------------------------------------------  
  
  delay(tik_s2);        //   0,2   
  lcd_clear();          //     
  LCD_start_zastavka(); //       
      
  pred_dlit_H = 1000;  //          
  zwuk_H_ON = 1;  //          
    
  delay(tik_2s);   //   2 
  
  pred_dlit_H = 50;  //          
  zwuk_H_ON = 1;  //          
          
  UART0init(9600);  //  UART0    9600 /
  UART1init(9600);  //  UART1    9600 /
   
  delay(tik_s2);   //   0,2 
  lcd_clear();          //           
 
//          ---------------------------
//               ,
//        ,   ,      
//--------------------------------------------------------------------------------------------------------
  Open(Command_Packet, 0); //   
  delay(tik_s5);   //   0,5            
    
  if(rx_ACK_Command == ON)  //        
     {
      //       
     rx_ACK_Command = OFF;  //         
     }
  else 
     { 
       //        
     LCD_oschibka();       //        
     LCD_GT511C();         //        "GT-511"
     lcd_pro_data(ERR_NO_GT511, 7); //  ,    :    
     
     pred_dlit_L = 1000;  //          
     zwuk_L_ON = 1;  //          
  
     while(1) {}   //  ,              
     }  
    
//     --------------------------------------------------------------------------  
  if (rx_ACK_Command_ERR == ON)  //           
     {
     LCD_oschibka();       //        
     LCD_GT511C();         //        "GT-511"  
     lcd_pro_data(ERR_ER_GT511, 7); //  ,    :     
     
     pred_dlit_L = 1000;  //          
     zwuk_L_ON = 1;  //          
  
     while(1) {}   //      
     }
//------------------------------------------------------------------------------------------------------------------    
  
//     -----------------------------------------------------------------------------
//            
  LED(Command_Packet, 1);  //     
  while (rx_ACK_Command == 0);  //        
  rx_ACK_Command = 0;  //         
   
  delay(tik_s5);   //   0,5   
    
  LED(Command_Packet, 0);  //    
  while (rx_ACK_Command == 0);  //        
  rx_ACK_Command = 0;  //         
//------------------------------------------------------------------------------------------------------------------   
    
//        I2C -------------------------------------  
//           ,            
//     ,          I2C
//       ,        I2C  
//----------------------------------------------------------------------------------------------------  
//       I2C 24LC64 -------------------------------------------------------------  
  I2C_addres = I2C_TEST_ADDR; //    24LC64
  I2Cwr_byte = I2C_TEST_DATA; //       24LC64
  wr_rd = 0; //  
  end_wr = 0; //   
  
  I2CONCLR = 0xFF; //    I2C
  I2CONSET = 0x40; //  I2C
  I2CONSET = 0x20; //   START I2C
//----------------------------------------------------------------------------------------------------    
  delay(tik_s5);   //   0,5       
  
  if (end_wr == 1)   //     , . .,  , 
                     //          I2C    
   {
   //           ------------------------------- 
     if ((rd_byte24LC64(I2C_TEST_ADDR)) ==  I2C_TEST_DATA)  //       
       {
       LCD_I2C_OK(0); //          I2C  
         
       pred_dlit_H = 500;  //         
       zwuk_H_ON = 1;  //          
 
       I2C_ON = 1;  //         I2C 
       
       delay(tik_1s);   //   1  
       }
  
     else    //        
       {
       LCD_oschibka();        //       
       lcd_pro_data(ERR_ER_I2C, 7); //  ,     I2C:    I2C
       LCD_I2C(64);             //     I2C  
     
       pred_dlit_L = 500;  //         
       zwuk_L_ON = 1;  //          
     
       I2C_ON = 0;  //         I2C 
       
       delay(tik_1s);   //   1  
       }  
   }  
  
  else   //      , . .,   , 
         //          I2C  
  {
  LCD_oschibka();       //        
  lcd_pro_data(ERR_NO_I2C, 7); //  ,     I2C:     I2C 
  LCD_I2C(64); //     I2C  
         
  pred_dlit_L = 500;  //          
  zwuk_L_ON = 1;  //          
     
  I2C_ON = 0;  //         I2C  
  
  delay(tik_1s);   //   1  
  }
//------------------------------------------------------------------------------------------------------------------
  
//    I2C (  )    --------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------  
  if  (I2C_ON == ON)  //          I2C  
     {  
     level_out = (rd_byte24LC64(level_out_I2C_ADDR)); //     I2C          
                                                          //     
     interval_out = (rd_byte24LC64(interval_out_I2C_ADDR)); //     I2C   , 
                                        //          
     }
  else   //     
     {
     level_out = level_out_AKT_DEF;  //         I2C
     interval_out =  interval_out_DEF;  //          I2C 
     }    
  
//-----------------------------------------------------------------------------------------------------------------
//           
//-----------------------------------------------------------------------------------------------------------------                
if (level_out == level_out_AKT_H)
   {
   KAN0_CLR;  //   - ,        
   }
else 
   {
   KAN0_SET;  //   - ,     
   }   
//----------------------------------------------------------------------------------------------------------------- 
  
  lcd_clear();          //   
  LCD_ishod_zastavka(); //   ()    : " "    
 
  flagn_kn0 = 0;    //   0
  flagn_kn1 = 0;    //   1
  flagn_kn2 = 0;    //   2
  
  WDTInit(); //    WDT -  WDT         -
    
//------------------------------------------------------------------------------------
//      
//---------------------------------------------------------------------------------
  while(1)               
  {

   WDTFeed(); // ("")   WDT -----------------------------------------------------------
              //      .                 
              //     .    
    
//         
  switch(rejim_ustr)
   {
      case REG_ISH: //   
      {   
   
//        
//------------------------------------------------------------------------    
     
    if  ((flagn_kn0 == 1)||(flagn_kn1 == 1)||(flagn_kn2 == 1))  //    0  1  2
        { 
          flagn_kn0 = 0;    //,    0
          flagn_kn1 = 0;    //,    1
          flagn_kn2 = 0;    //,    2
          
          pred_dlit_H = 50;  //         
          zwuk_H_ON = 1;  //                       
                   
         //        -------------------------------------------           
          LED(Command_Packet, 1);  //     
          while (rx_ACK_Command == 0);  //        
          rx_ACK_Command = 0;  //         
   
          delay(tik_s3);   //   0,3   
  
          RemoveFinger(Command_Packet);  //,          
          while (rx_ACK_Command == 0);  //        
          rx_ACK_Command = 0;  //          
  
          //      
          lcd_clear();          //     
          if ((ACK_Packet[4] + (ACK_Packet[5] * 256)) != 0)  //      
              {
              lcd_clear();          //   
              LCD_palez_ne_prilogen(); //       
           
              LED(Command_Packet, 0);  //    
              while (rx_ACK_Command == 0);  //        
              rx_ACK_Command = 0;  //          
             
              pred_dlit_L = 300;  //          
              zwuk_L_ON = 1;  //          
              delay(tik_1s);   //   1   
                    
              lcd_clear();          //  
              LCD_ishod_zastavka(); //   ()    : " "
              break;  //       
              }  
                                             
          //                   
          LCD_idet_analiz();  //        
          delay(tik_s1);   //   0,1   
          CaptureFinger(Command_Packet, 0); //      
          while (rx_ACK_Command == 0);  //        
          rx_ACK_Command = 0;  //           
                       
           delay(tik_s1);   //   0,1  
          
          Identify(Command_Packet); //          (1:N)  
          while (rx_ACK_Command == 0);  //        
          rx_ACK_Command = 0;  //          
                                      
                //      ,             -         
                if ((ACK_Packet[8] == ACK) & ((ACK_Packet[4] + (ACK_Packet[5] * 256)) == ID0))  
                   {                     
                   LED(Command_Packet, 0);  //    
                   while (rx_ACK_Command == 0);  //        
                   rx_ACK_Command = 0;  //           
                                       
                   pred_dlit_H = 300;  //         
                   zwuk_H_ON = 1;  //               
                   
                   //-------------------------------------------------------------------------------------------------------------------------------------
                   rejim_ustr = REG_MAST;  //  -  ----------------------------------------------------------------------
                   rejim_glubina = 0;    //   (0)      
                   podrejim_mast =  PODREG_MAST_U;    //   -           
                   //--------------------------------------------------------------------------------------------------------------------------------------
                  
                   lcd_clear();          //   
                   LCD_master_rejim();  //     -  
                   WDTFeed(); // ("")   WDT -----------------------------------------------------------
                   delay(tik_2s);   //   2  
                   pred_dlit_H = 300;  //         
                   zwuk_H_ON = 1;  //          

                   flagn_kn0 = 0;    //    0  Ent (  ,    ) 
                   flagn_kn1 = 0;    //    1  Ret (  ,    )           
                   flagn_kn2 = 0;    //    2  Sel (  ,    ) 
                                     
                   lcd_clear();          //   
                   LCD_kursor_menu_master_rejim(podrejim_mast);  //     -   
                   break;  //          
                   }            
                    
                //      ,         ,     - 
                if ((ACK_Packet[8] == ACK) & ((ACK_Packet[4] + (ACK_Packet[5] * 256)) != ID0)) 
                   {
                   tempor  = (ACK_Packet[4] + (ACK_Packet[5] * 256)); //       
                                      
                   LED(Command_Packet, 0);  //    
                   while (rx_ACK_Command == 0);  //        
                   rx_ACK_Command = 0;  //           
                   
                   //----------------------------------------------------------------------------------------------------------------------- 
                   //    I2C (  )    ---------------------------------------------
                   //-----------------------------------------------------------------------------------------------------------------------  
                   if  (I2C_ON == ON)  //          I2C  
                       {  
                       level_out = (rd_byte24LC64(level_out_I2C_ADDR)); //     I2C          
                                                                        //     
                       interval_out = (rd_byte24LC64(interval_out_I2C_ADDR)); //     I2C   , 
                                                      //          
                             
                       ID_dostup = (rd_byte24LC64(ID_dostup_START_I2C_ADDR + tempor)); //     I2C        
                                                                            //       ID
                                       
                            //          
                            if (ID_dostup == ID_dostup_OFF)   
                               {
                               pred_dlit_L = 500;  //         
                               zwuk_L_ON = 1;  //           
                                     
                               lcd_clear();          //   
                               LCD_otkaz_w_dostupe();  //         
                               lcd_pro_data('-', 71);   //      , ,  
                               //    ,         
                               
                               WDTFeed(); // ("")   WDT -----------------------------------------------------------
                               delay(tik_2s);   //   2 
                               lcd_clear();          //   
                               LCD_ishod_zastavka(); //   ()    : " "
                  
                               flagn_kn0 = 0;    //    0  Ent (  ,    ) 
                               flagn_kn1 = 0;    //    1  Ret (  ,    )           
                               flagn_kn2 = 0;    //    2  Sel (  ,    )                   
                  
                               break;  //       
                               }
                            //----------------------------------------------------------------------------------------------------------------------------
                            //            
                       }
                   else   //     
                       {
                       level_out = level_out_AKT_DEF;  //         I2C
                       interval_out =  interval_out_DEF;  //          I2C                          
                       ID_dostup = ID_dostup_ON;  //              I2C  
                       }   

                   pred_dlit_H = 500;  //         
                   zwuk_H_ON = 1;  //             
                                    
                   lcd_clear();             //    
                   LCD_dostup_otkr();  //        
                         
                   //                
                   r100 = tempor / 100;
                   tempor = tempor % 100;
                   r10 = tempor / 10;
                   r1 = tempor % 10; 
                   //            
                   lcd_pro_data(r100, 69);
                   lcd_pro_data(r10, 70);
                   lcd_pro_data(r1, 71);    
                   
                   //---------------------------------------------------------------------------------------------------------------------------
                   //         
                   //          
                   //---------------------------------------------------------------------------------------------------------------------------                
                   if (level_out == level_out_AKT_H)   //    -   
                      {                
                      KAN0_SET;  //          
                      }
                   else  //    - 
                      {             
                      KAN0_CLR;  //         
                      }     
                   
                   //-------------------------------------------------------------------------------
                   //                                
                   count_interval_out = interval_out_MIN;   
                   delay(tik_1s);   //   1  
                   WDTFeed(); // ("")   WDT ----------------------------------------------------------- 
                   
                   while (count_interval_out < interval_out)
                      {
                      count_interval_out = count_interval_out + 1;  
                      delay(tik_1s);   //   1  
                      WDTFeed(); // ("")   WDT -----------------------------------------------------------
                      } 
                   //-----------------------------------------------------------------------------                 
                   if (level_out == level_out_AKT_H)   //    -   
                      {
                      KAN0_CLR;  //                       
                      }
                   else   //    - 
                      {             
                      KAN0_SET;  //          
                      }                            
                   //--------------------------------------------------------------------------------------------------------------------------- 
                   
                   WDTFeed(); // ("")   WDT -----------------------------------------------------------                
                   delay(tik_s5);   //   0,5 
                   lcd_clear();          //   
                   LCD_ishod_zastavka(); //   ()    : " "
                   
                   flagn_kn0 = 0;    //    0  Ent (  ,    ) 
                   flagn_kn1 = 0;    //    1  Ret (  ,    )           
                   flagn_kn2 = 0;    //    2  Sel (  ,    ) 
                   
                   break;  //       
                   //-------------------------------------------------------------------------------------------------------
                   }                
                                       
                   //      ,            ------------------ 
                   LED(Command_Packet, 0);  //    
                   while (rx_ACK_Command == 0);  //        
                   rx_ACK_Command = 0;  //         
                 
                   pred_dlit_L = 500;  //         
                   zwuk_L_ON = 1;  //           
                                     
                   lcd_clear();          //   
                   LCD_otkaz_w_dostupe();  //         
                  
                   WDTFeed(); // ("")   WDT -----------------------------------------------------------
                   delay(tik_2s);   //   2 
                   lcd_clear();          //   
                   LCD_ishod_zastavka(); //   ()    : " "
                  
                   flagn_kn0 = 0;    //    0  Ent (  ,    ) 
                   flagn_kn1 = 0;    //    1  Ret (  ,    )           
                   flagn_kn2 = 0;    //    2  Sel (  ,    )                   
                  
                   break;  //       
                   //---------------------------------------------------------------------------------------------------------------------------- 
                  
      }  // if  (flagn_kn0 == 1)  
                 
   }  // case REG_ISH: //   
   break;
        
//------------------------------------------------------------------------------------------   
   case REG_MAST:  // -
   {             
     if (rejim_glubina == 0)    //    (0)     
       {
       //      Sel    
       //------------------------------------------------------------------------        
       if  (flagn_kn2 == 1)    //    2
            {
            flagn_kn2 = 0;    //,     2
         
            pred_dlit_H = 50;  //         
            zwuk_H_ON = 1;  //          
        
            //  -   -------------------------------------------
            podrejim_mast =  podrejim_mast + 1; 
        
            if (podrejim_mast == (PODREG_MAST_S + 1))
               {
               podrejim_mast = PODREG_MAST_U;
               }
            LCD_kursor_menu_master_rejim(podrejim_mast);  //     -  
            //--------------------------------------------------------------------------------------------
      
            } // if  (flagn_kn2 == 1)
       //------------------------------------------------------------------------     

       
       //      Ent 
       //------------------------------------------------------------------------    
       if  (flagn_kn0 == 1)    //    0 
            {
            flagn_kn0 = 0;    //,    0
          
            pred_dlit_H = 50;  //         
            zwuk_H_ON = 1;  //                  
    
            rejim_glubina = 1;    //    (1)    
            //--------------------------------------------------------------------------------------
            lcd_clear();             //    
                     
            switch (podrejim_mast) 
               {
               case PODREG_MAST_U: //             
                  {
                  LCD_Akt_ur(0);   //              
 
                  lcd_pro_data('*',64); //     (  )   
      
                  //    I2C (  )    --------------------------------------------
                  //-----------------------------------------------------------------------------------------------------------------------  
                  if  (I2C_ON == ON)  //          I2C  
                      {  
                      level_out = (rd_byte24LC64(level_out_I2C_ADDR)); //     I2C          
                                                                  //     
                      }
                  else   //     
                      {
                      level_out = level_out_AKT_DEF;  //          I2C
                      }    
                  //----------------------------------------------------------------------------------------------------------------------
                  
                  LCD_Zn_Akt_ur(level_out);   //                  
                  }
               break; 
                    
               case PODREG_MAST_I: //          
                  {            
                  LCD_Interv(0);  //                
                   
                  lcd_pro_data('*',64);  //     (  )          
                  lcd_pro_data('c',69);  //     -   
                  lcd_pro_data('e',70);
                  lcd_pro_data(rus_k,71);
                                 
                  //    I2C (  )    --------------------------------------------
                  //-----------------------------------------------------------------------------------------------------------------------  
                  if  (I2C_ON == ON)  //          I2C  
                      {  
                      interval_out = (rd_byte24LC64(interval_out_I2C_ADDR)); //     I2C   , 
                                                        //          
                      }
                  else   //     
                      {
                      interval_out =  interval_out_DEF;  //           I2C 
                      }    
                  //----------------------------------------------------------------------------------------------------------------------
                   
                  tempor = interval_out; 
                  //        
                  r100 = tempor / 100;
                  tempor = tempor % 100;
                  r10 = tempor / 10;
                  r1 = tempor % 10; 
                  //    
                  lcd_pro_data(r100, 65);
                  lcd_pro_data(r10, 66);
                  lcd_pro_data(r1, 67);   
                  } 
              break;
    
              case PODREG_MAST_G: //        
                  {             
                  LCD_GetEnrollCount(0); //      -      
                  LCD_Zapros(); //    -                       
                  } 
              break;
    
              case PODREG_MAST_C: //   ,        
                  {             
                  LCD_CheckEnrolled(0);  //     ,      ID   
                  LCD_ID_ravno();  //    ,        
                  ID_GT511 = ID_GT511_MIN; //      
                  tempor = ID_GT511; 
                  //        
                  r100 = tempor / 100;
                  tempor = tempor % 100;
                  r10 = tempor / 10;
                  r1 = tempor % 10; 
                  //    
                  lcd_pro_data(r100, 67);
                  lcd_pro_data(r10, 68);
                  lcd_pro_data(r1, 69);   
                  } 
              break;
              
              case PODREG_MAST_S: //     --
                  {             
                  LCD_Super_master(0);  //       --   
                  LCD_Palez();  //      -- (    )   
                  } 
              break;             
              }  // switch (podrejim_mast)
        } // if  (flagn_kn0 == 1)
  //------------------------------------------------------------------------     
     } // if (rejim_glubina == 0)    //    (0)    
   
      
     
   if (rejim_glubina == 1)    //    (1)     
       {
       //      Ret    
       //------------------------------------------------------------------------  
       if  (flagn_kn1 == 1)    //    1 
            {
            flagn_kn1 = 0;    //,     1
     
            pred_dlit_H = 50;  //         
            zwuk_H_ON = 1;  //           
                 
            //         --------------------------
            lcd_clear();             //    
            rejim_glubina = 0;    //   (0)    
            LCD_kursor_menu_master_rejim(podrejim_mast);  //     -  
            //---------------------------------------------------------------------      
                  
            } // if  (flagn_kn1 == 1)
        
  
       //      Sel    
       //------------------------------------------------------------------------        
       if  (flagn_kn2 == 1)    //    2
            {
            flagn_kn2 = 0;    //,     2
         
            pred_dlit_H = 50;  //         
            zwuk_H_ON = 1;  //          
        
            switch (podrejim_mast) 
               {
               case PODREG_MAST_U: //             
                  {                    
                  if (level_out ==  level_out_AKT_H)
                      {   
                      level_out = level_out_AKT_L;
                      }
                  else  
                      {
                      level_out = level_out_AKT_H;
                      }
                  lcd_pro_data(pusto,64); //        (  )                      
                  LCD_Zn_Akt_ur(level_out);   //            
                  }
               break; 
                    
               case PODREG_MAST_I: //          
                  {            
                   interval_out = interval_out + 1;
                   if (interval_out > interval_out_MAX)                
                      {                    
                      interval_out = interval_out_MIN; 
                      }  

                   lcd_pro_data(pusto,64); //        (  )       
                   tempor = interval_out; 
                   //      
                   r100 = tempor / 100;
                   tempor = tempor % 100;
                   r10 = tempor / 10;
                   r1 = tempor % 10; 
                   //    
                   lcd_pro_data(r100, 65);
                   lcd_pro_data(r10, 66);
                   lcd_pro_data(r1, 67);   
                  } 
              break;
    
              case PODREG_MAST_G: //        
                  {} 
              break;
    
              case PODREG_MAST_C: //   ,        
                  {
                   lcd_pro_data(pusto, 71);  //       
                    
                   ID_GT511 = ID_GT511 + 1;
                   if (ID_GT511 > ID_GT511_MAX)                
                      {                    
                      ID_GT511 = ID_GT511_MIN; 
                      }                      
                   
                   tempor = ID_GT511; 
                   //        
                   r100 = tempor / 100;
                   tempor = tempor % 100;
                   r10 = tempor / 10;
                   r1 = tempor % 10; 
                   //    
                   lcd_pro_data(r100, 67);
                   lcd_pro_data(r10, 68);
                   lcd_pro_data(r1, 69);
                   
                   CheckEnroll(Command_Packet, ID_GT511);   //,          
                   while (rx_ACK_Command == 0);  //        
                   rx_ACK_Command = 0;  //          
                                  
                  //  /   
                       if  (ACK_Packet[8] == ACK) 
                          {
                          lcd_pro_data('+', 70);
                          }
                       if  (ACK_Packet[8] == NACK) 
                          {
                          lcd_pro_data('-', 70);
                          }
                       
                  delay(tik_s2);   //   0,2     

                  //    I2C (  )    --------------------------------------------
                  //-----------------------------------------------------------------------------------------------------------------------  
                  if  (I2C_ON == ON)  //          I2C  
                      {  
                      ID_dostup = (rd_byte24LC64(ID_dostup_START_I2C_ADDR + ID_GT511)); //     I2C        
                                                                            //    
                      pred_dlit_H = 50;  //         
                      zwuk_H_ON = 1;  //           
                      }
                  else   //     
                      {
                      pred_dlit_L = 50;  //         
                      zwuk_L_ON = 1;  //           
                      
                      ID_dostup = ID_dostup_DEF;  //          
                      }                       
                               
                  //      
                  if (ID_dostup == ID_dostup_OFF)   
                     {
                     lcd_pro_data('-', 71);   
                     } 
                  else 
                     {
                     lcd_pro_data('+', 71);   
                     }                                             
                  } 
              break;
              
              case PODREG_MAST_S: //     --
                  {} 
              break;                 
              }  // switch (podrejim_mast)
            } // if  (flagn_kn2 == 1)
       //------------------------------------------------------------------------     

       
       //      Ent 
       //------------------------------------------------------------------------    
       if  (flagn_kn0 == 1)    //    0 
            {
            flagn_kn0 = 0;    //,    0
          
            pred_dlit_H = 50;  //         
            zwuk_H_ON = 1;  //                  
               
            //--------------------------------------------------------------------------------------
                                 
            switch (podrejim_mast) 
               {
               case PODREG_MAST_U: //             
                  {   
               //    I2C (  )    --------------------------------------------
               //-----------------------------------------------------------------------------------------------------------------------  
                  if  (I2C_ON == ON)  //          I2C  
                      {  
                      wr_byte24LC64(level_out, level_out_I2C_ADDR);  //     I2C  
                                                         //         
                      delay(tik_s5);   //   0,5         
                                
                      level_out = (rd_byte24LC64(level_out_I2C_ADDR)); //     I2C          
                                                                  //     
                      pred_dlit_H = 500;  //         
                      zwuk_H_ON = 1;  //           
                      }
                  else   //     
                      {
                      pred_dlit_L = 500;  //         
                      zwuk_L_ON = 1;  //           
                      
                      level_out = level_out_AKT_DEF;  //          
                      }
 
                      lcd_pro_data('*',64); //     (  )   
                      LCD_Zn_Akt_ur(level_out);   //                                    
               //----------------------------------------------------------------------------------------------------------------------
                  }
               break; 
                    
               case PODREG_MAST_I: //          
                  {                                  
            
               //    I2C (  )    --------------------------------------------
               //-----------------------------------------------------------------------------------------------------------------------  
                  if  (I2C_ON == ON)  //          I2C  
                      {  
                      wr_byte24LC64(interval_out, interval_out_I2C_ADDR);  //     I2C  
                                                         //         
                      delay(tik_s5);   //   0,5        
                                
                      interval_out = (rd_byte24LC64(interval_out_I2C_ADDR)); //     I2C          
                                                                            //     
                      pred_dlit_H = 500;  //         
                      zwuk_H_ON = 1;  //           
                      }
                  else   //     
                      {
                      pred_dlit_L = 500;  //         
                      zwuk_L_ON = 1;  //           
                      
                      interval_out = interval_out_DEF;  //    (    )
                      }
                  
                      lcd_pro_data('*',64); //     (  )   
                      tempor = interval_out; 
                      //      
                      r100 = tempor / 100;
                      tempor = tempor % 100;
                      r10 = tempor / 10;
                      r1 = tempor % 10; 
                      //    
                      lcd_pro_data(r100, 65);
                      lcd_pro_data(r10, 66);
                      lcd_pro_data(r1, 67);   
               //----------------------------------------------------------------------------------------------------------------------            
                  } 
              break;
    
              case PODREG_MAST_G: //        
                  {             
                  lcd_clear();             //     
                  delay(tik_s1);   //   0,1                 
                  
                  GetEnrollCount(Command_Packet); //          
                  while (rx_ACK_Command == 0);  //        
                  rx_ACK_Command = 0;  //          
  
                  //      
                  tempor  = (ACK_Packet[4] + (ACK_Packet[5] * 256)); //          
                                   
                  delay(tik_s2);   //   0,2  
                  
                  LCD_GetEnrollCount(0); //      -      
                  
                  pred_dlit_H = 100;  //         
                  zwuk_H_ON = 1;  //            
                 
                  lcd_pro_data('*',64);  //     (  )          
                  
                  //                
                  r100 = tempor / 100;
                  tempor = tempor % 100;
                  r10 = tempor / 10;
                  r1 = tempor % 10; 
                  //            
                  lcd_pro_data(r100, 65);
                  lcd_pro_data(r10, 66);
                  lcd_pro_data(r1, 67);   
                  } 
              break;
    
              case PODREG_MAST_C: //   ,        
                  {              
                  delay(tik_s2);   //   0,2                  
                    
                  //             
                  if (ID_dostup == ID_dostup_OFF)   
                     {
                     ID_dostup = ID_dostup_ON;
                     } 
                  else 
                     {
                     ID_dostup = ID_dostup_OFF;
                     }                     
                  
                 //    I2C (  )    --------------------------------------------
                 //-----------------------------------------------------------------------------------------------------------------------  
                  if  (I2C_ON == ON)  //          I2C  
                      {  
                      wr_byte24LC64(ID_dostup, (ID_dostup_START_I2C_ADDR + ID_GT511));  //     I2C  
                                                         //       
                      delay(tik_s2);   //   0,2        
                                
                      ID_dostup = (rd_byte24LC64(ID_dostup_START_I2C_ADDR + ID_GT511)); //     I2C        
                                                                            //    
                      pred_dlit_H = 500;  //         
                      zwuk_H_ON = 1;  //           
                      }
                  else   //     
                      {
                      pred_dlit_L = 500;  //         
                      zwuk_L_ON = 1;  //           
                      
                      ID_dostup = ID_dostup_DEF;  //          
                      }
 
                  //      
                  if (ID_dostup == ID_dostup_OFF)   
                     {
                     lcd_pro_data('-', 71);   
                     } 
                  else 
                     {
                     lcd_pro_data('+', 71);   
                     }                      
                  //----------------------------------------------------------------------------------------------------------------------                    
                  } 
              break;
                           
              case PODREG_MAST_S: //     --
                  {
                  //        -------------------------------------------           
                  LED(Command_Packet, 1);  //     
                  while (rx_ACK_Command == 0);  //        
                  rx_ACK_Command = 0;  //         
   
                  delay(tik_s2);   //   0,2   
  
                  RemoveFinger(Command_Packet);  //,          
                  while (rx_ACK_Command == 0);  //        
                  rx_ACK_Command = 0;  //          
  
                  //      
                  lcd_clear();          //     
                  if ((ACK_Packet[4] + (ACK_Packet[5] * 256)) != 0)  //      
                      {
                      lcd_clear();          //   
                      LCD_palez_ne_prilogen(); //        
           
                      LED(Command_Packet, 0);  //    
                      while (rx_ACK_Command == 0);  //        
                      rx_ACK_Command = 0;  //          
             
                      pred_dlit_L = 500;  //          
                      zwuk_L_ON = 1;  //          
                      
                      WDTFeed(); // ("")   WDT -----------------------------------------------------------
                      delay(tik_1s);   //   1   
       
                      lcd_clear();          //   
                      //         --------------------------
                      rejim_glubina = 0;    //   (0)    
                      LCD_kursor_menu_master_rejim(podrejim_mast);  //     -  
                      //---------------------------------------------------------------------         
                      break;  //      
                      }  
                                             
                      //                   
                      LCD_idet_analiz();  //        
                      delay(tik_s1);   //   0,1   
                      CaptureFinger(Command_Packet, 0); //      
                      while (rx_ACK_Command == 0);  //        
                      rx_ACK_Command = 0;  //           
 
                      delay(tik_s1);   //   0,1   
                       
                      Identify(Command_Packet); //          (1:N)  
                      while (rx_ACK_Command == 0);  //        
                      rx_ACK_Command = 0;  //          
                                         
                      //      ,             --         
                      if ((ACK_Packet[8] == ACK) & ((ACK_Packet[4] + (ACK_Packet[5] * 256)) == ID1))  
                          {                     
                          LED(Command_Packet, 0);  //    
                          while (rx_ACK_Command == 0);  //        
                          rx_ACK_Command = 0;  //           
                                       
                          pred_dlit_H = 500;  //         
                          zwuk_H_ON = 1;  //               
                   
                          //-------------------------------------------------------------------------------------------------------------------------------------
                          Termination(Command_Packet);  //   
                          while (rx_ACK_Command == 0);  //        
                          rx_ACK_Command = 0;  //           
                          
                          delay(tik_1s);   //   1   
                          rejim_ustr = REG_SUPER;  //  --  ----------------------------------------------------------------------
                          //--------------------------------------------------------------------------------------------------------------------------------------
                                                         
                          lcd_clear();          //   
                          LCD_super_master_rejim();  //     --  
                          
                          WDTFeed(); // ("")   WDT -----------------------------------------------------------
                          delay(tik_1s);   //   1  
                          pred_dlit_H = 500;  //         
                          zwuk_H_ON = 1;  //          
                   
                          while (1)   //  ,         
                            {
                            delay(tik_1s);   //   1     
                            WDTFeed(); // ("")   WDT -----------------------------------------------------------  
                            }  
                          }
                                    
                      //         ------------------ 
                      LED(Command_Packet, 0);  //    
                      while (rx_ACK_Command == 0);  //        
                      rx_ACK_Command = 0;  //         
                 
                      pred_dlit_L = 300;  //         
                      zwuk_L_ON = 1;  //           
                                     
                      lcd_clear();          //   
                      LCD_otkaz_w_dostupe();  //           
           
                      WDTFeed(); // ("")   WDT -----------------------------------------------------------
                      delay(tik_2s);   //   2                   
                                            
                      lcd_clear();          //   
                      //         --------------------------
                      rejim_glubina = 0;    //   (0)    
                      LCD_kursor_menu_master_rejim(podrejim_mast);  //     -  
                      //---------------------------------------------------------------------         
                 } 
              break;
             
              }  // switch (podrejim_mast)
            } // if  (flagn_kn0 == 1)
  //------------------------------------------------------------------------     
     } // if (rejim_glubina == 1)    //    (1)       
       
   }  // case REG_MAST:  // -
   break; 
   
  } // switch(rejim_ustr)
 }   //while         
}    //main
//------------------------------------------------------------------------------- 


//      
//------------------------------------------------------------------------------
void LCD_start_zastavka()
{
  lcd_pro_data('F', 0);
  lcd_tek_data('P');
  lcd_tek_data('c');
  lcd_tek_data('e');
  lcd_tek_data('n');
  lcd_tek_data('s');
  lcd_tek_data('o');
  lcd_tek_data('r');
  lcd_pro_data('V', 66);
  lcd_tek_data(num_Ver + 0x30);
  lcd_tek_data('.');
  lcd_tek_data(num_coma_Ver + 0x30);
}

//   ()      
//------------------------------------------------------------------------------
void LCD_ishod_zastavka()
{
  lcd_pro_data(rus_J, 2);
  lcd_tek_data(rus_d);
  lcd_tek_data('y');
  
  lcd_pro_data(rus_p, 65);
  lcd_tek_data('a');
  lcd_tek_data(rus_l);
  lcd_tek_data('e');
  lcd_tek_data(rus_tz);
}

//           
//------------------------------------------------------------------------------
void LCD_palez_ne_prilogen()
{
  lcd_pro_data(rus_P, 0);
  lcd_tek_data('a');
  lcd_tek_data(rus_l);
  lcd_tek_data('e');
  lcd_tek_data(rus_tz);
  lcd_tek_data(pusto);
  lcd_tek_data(rus_n);
  lcd_tek_data('e');
  
  lcd_pro_data(rus_p, 64);
  lcd_tek_data('p');
  lcd_tek_data(rus_i);
  lcd_tek_data(rus_l);
  lcd_tek_data('o');
  lcd_tek_data(rus_j);
  lcd_tek_data('e');
  lcd_tek_data(rus_n);
}

//           
//------------------------------------------------------------------------------
void LCD_oschibka()
{
  lcd_pro_data('O', 0);
  lcd_tek_data(rus_sch);
  lcd_tek_data(rus_i);
  lcd_tek_data(rus_b);
  lcd_tek_data(rus_k);
  lcd_tek_data('a');
}

//        "GT-511C"  
//------------------------------------------------------------------------------
void LCD_GT511C()
{
  lcd_pro_data('G', 64);
  lcd_tek_data('T');
  lcd_tek_data('-');
  lcd_tek_data('5');
  lcd_tek_data('1');
  lcd_tek_data('1');
  lcd_tek_data('C');
}

//          
//------------------------------------------------------------------------------
void LCD_idet_analiz()
{
  lcd_pro_data(rus_I, 2);
  lcd_tek_data(rus_d);
  lcd_tek_data('e');
  lcd_tek_data(rus_t);
  
  lcd_pro_data('a', 65);
  lcd_tek_data(rus_n);
  lcd_tek_data('a');
  lcd_tek_data(rus_l);
  lcd_tek_data(rus_i);
  lcd_tek_data(rus_z);
}

//          I2C   
//------------------------------------------------------------------------------
void LCD_I2C_OK(unsigned int adr)
{
  lcd_pro_data('I', adr);
  lcd_tek_data('2');
  lcd_tek_data('C');
  lcd_tek_data(pusto);
  lcd_tek_data('O');
  lcd_tek_data('K');
}

//     I2C   
//------------------------------------------------------------------------------
void LCD_I2C(unsigned int adr)
{
  lcd_pro_data('I', adr);
  lcd_tek_data('2');
  lcd_tek_data('C');
}


//          
//------------------------------------------------------------------------------
void LCD_dostup_otkr()
{
  lcd_pro_data(rus_D, 1);
  lcd_tek_data('o');
  lcd_tek_data('c');
  lcd_tek_data(rus_t);
  lcd_tek_data('y');
  lcd_tek_data(rus_p);
 
  lcd_pro_data('o', 64);
  lcd_tek_data(rus_t);
  lcd_tek_data(rus_k);
  lcd_tek_data('p');
  lcd_tek_data('.');
}

//           
//------------------------------------------------------------------------------
void LCD_otkaz_w_dostupe()
{
  lcd_pro_data('O', 0);
  lcd_tek_data(rus_t);
  lcd_tek_data(rus_k);
  lcd_tek_data('a');
  lcd_tek_data(rus_z);
  lcd_tek_data(pusto);
  lcd_tek_data(rus_v);
  
  lcd_pro_data(rus_d, 64);
  lcd_tek_data('o');
  lcd_tek_data('c');
  lcd_tek_data(rus_t);
  lcd_tek_data('y');
  lcd_tek_data(rus_p);
  lcd_tek_data('e');
}

//      -    
//------------------------------------------------------------------------------
void LCD_master_rejim()
{
  lcd_pro_data('M', 0);
  lcd_tek_data('a');
  lcd_tek_data('c');
  lcd_tek_data(rus_t);
  lcd_tek_data('e');
  lcd_tek_data('p');
  lcd_tek_data('-');
  
  lcd_pro_data('p', 65);
  lcd_tek_data('e');
  lcd_tek_data(rus_j);
  lcd_tek_data(rus_i);
  lcd_tek_data(rus_m);
}

//      --  
//------------------------------------------------------------------------------
void LCD_super_master_rejim()  
{
  lcd_pro_data(rus_U, 0);
  lcd_tek_data(rus_p);
  lcd_tek_data('p');
  lcd_tek_data('a');
  lcd_tek_data(rus_v);
  lcd_tek_data(rus_l);
  lcd_tek_data('.'); 
  
  LCD_GT511C(); //        "GT-511"   65  
}  

//            
//------------------------------------------------------------------------------ 
void LCD_Akt_ur(unsigned int adr)
{
  lcd_pro_data('A', adr);
  lcd_tek_data(rus_k);
  lcd_tek_data(rus_t);
  lcd_tek_data('.');
  lcd_tek_data('y');
  lcd_tek_data('p');
  lcd_tek_data('.');
}

//            
//------------------------------------------------------------------------------
void LCD_Interv(unsigned int adr)
{
  lcd_pro_data(rus_I, adr);
  lcd_tek_data(rus_n);
  lcd_tek_data(rus_t);
  lcd_tek_data('e');
  lcd_tek_data('p');
  lcd_tek_data(rus_v);
  lcd_tek_data('.');
}  
  
  

//      -       
//------------------------------------------------------------------------------
void LCD_GetEnrollCount(unsigned int adr)
{
  lcd_pro_data('K', adr);
  lcd_tek_data('o');
  lcd_tek_data(rus_l);
  lcd_tek_data('.');
  lcd_tek_data('o');
  lcd_tek_data(rus_t);
  lcd_tek_data(rus_p);
}  


//     ,      ID     
//------------------------------------------------------------------------------
void LCD_CheckEnrolled(unsigned int adr)
{
  lcd_pro_data('H', adr);
  lcd_tek_data('o');
  lcd_tek_data(rus_m);
  lcd_tek_data('.');
  lcd_tek_data('o');
  lcd_tek_data(rus_t);
  lcd_tek_data(rus_p);
}  

//       --
//------------------------------------------------------------------------------
void LCD_Super_master(unsigned int adr)  
{
  lcd_pro_data(rus_U, adr);
  lcd_tek_data(rus_p);
  lcd_tek_data('p');
  lcd_tek_data('.');
  lcd_tek_data(pusto);
  lcd_tek_data('G');
  lcd_tek_data('T');
}

//     -  
//        -
//------------------------------------------------------------------------------
void LCD_kursor_menu_master_rejim(unsigned int podrejim)
{
  
   lcd_pro_data('>', 0);  //        
   switch (podrejim)
    {
     case PODREG_MAST_U: //             
        {
        LCD_Akt_ur(1);   //              
        LCD_Interv(65);  //              
        }
     break; 
                    
     case PODREG_MAST_I: //          
        {            
        LCD_Interv(1);  //                
        LCD_GetEnrollCount(65); //      -       
        } 
     break;
    
     case PODREG_MAST_G: //        
        {             
        LCD_GetEnrollCount(1); //      -      
        LCD_CheckEnrolled(65);  //     ,      ID      
        } 
     break;
    
     case PODREG_MAST_C: //   ,        
        {             
        LCD_CheckEnrolled(1);  //     ,      ID   
        LCD_Super_master(65);  //       -- 
        } 
     break;
     
      case PODREG_MAST_S: //     --
        {             
        LCD_Super_master(1);  //       --
        LCD_Akt_ur(65);   //          
        } 
     break;
    }
}

//            
//------------------------------------------------------------------------------ 
void LCD_Zn_Akt_ur(unsigned int level)
{ 
   if (level == 0)   //    -   
     {
     lcd_pro_data('B', 65);
     lcd_tek_data(rus_ii);
     lcd_tek_data('c');
     lcd_tek_data('o');
     lcd_tek_data(rus_k);
     lcd_tek_data(rus_i);
     lcd_tek_data(rus_ik);
     }
   if (level == 1)   //    -  
     {
     lcd_pro_data('H', 65);
     lcd_tek_data(rus_i);
     lcd_tek_data(rus_z);
     lcd_tek_data(rus_k);
     lcd_tek_data(rus_i);
     lcd_tek_data(rus_ik);
     lcd_tek_data(pusto);
     }
}

//    -      
//    ,        
//------------------------------------------------------------------------------
void LCD_Zapros()
{
  lcd_pro_data(rus_Z, 64);
  lcd_tek_data('a');
  lcd_tek_data(rus_p);
  lcd_tek_data('p');
  lcd_tek_data('o');
  lcd_tek_data('c');
  lcd_tek_data('?');
}  

//    ,          
//------------------------------------------------------------------------------
void LCD_ID_ravno()
{
  lcd_pro_data('I', 64);
  lcd_tek_data('D');
  lcd_tek_data('=');
}  

//      --   
//------------------------------------------------------------------------------
void LCD_Palez()
{
  lcd_pro_data(rus_P, 65);
  lcd_tek_data('a');
  lcd_tek_data(rus_l);
  lcd_tek_data('e');
  lcd_tek_data(rus_tz);
  lcd_tek_data('?');
}


