//------------------------------------------------------------------------
//   -   RTC
//-------------------------------------------------------------------------
//#include "hardware.h" //     
#include "rtc.h" //     
#include "lcd.h" //     

#define  FOSC32k   32768

#define  MAX_YEAR   2050  //   
#define  MIN_YEAR   1990  //    

//     
unsigned int sec=0;   // 
unsigned int min=0;   // 
unsigned int hour=0;  // 
unsigned int dow=0;   //  
unsigned int dom=0;   //  
unsigned int month=0;  // 
unsigned int year=0;   // 

//           
volatile unsigned int  min10=0; //   
volatile unsigned int  min1=0; //   
volatile unsigned int  hour10=0; //   
volatile unsigned int  hour1=0; //  
volatile unsigned int  sek10=0; //   
volatile unsigned int  sek1=0; //  

volatile unsigned int  sek_ritm=0;  //  

unsigned int r1000=0;   //-----------------------------------
unsigned int r100=0;    //   
unsigned int r10=0;     //
unsigned int r1=0;      //-----------------------------------

//      RTC
#define MASKSEC 0x3F    // 0b11.1111
#define MASKMIN 0x3F00  // 0b11.1111.0000.0000
#define MASKHOUR 0x1F0000 // 0b1.1111.0000.0000.0000.0000
#define MASKDOW 0x7000000 // 0b111.0000.0000.0000.0000.0000.0000
#define MASKDOM 0x1F      // 0b1.1111
#define MASKMONTH 0xF00  // 0b1111.0000.0000
#define MASKYEAR 0xFFF0000 // 0b1111.1111.1111.0000.0000.0000.0000
#define MASKDOY 0xFFF     // 0b1111.1111.1111

//          CTC
#define MASKCTC 0x4000     // 0b100.0000.0000.0000

//   RTC
void RTCinit()
      {
        CCR = 0x2;   //     CTC   
        CCR = 0x0;   //     
        ILR = 0x3;   //   RTC
        CIIR = 0x0; //     
	AMR = 0xFF; //    RTC  ()

//---------------   -----------------
	//     
//        PREINT = (int)(FOSC/FOSC32k)-1;
//        PREFRAC = FOSC-((PREINT+1)*FOSC32k);
    // pclk = 14745600  PREINT = int(14745600/32768)-1 = int(450)-1 = 449
    //PREFRAC = 14745600 - ((449 + 1) x 32768) = 0
//--------------------------------------------------------------------------
        RTCstart();  //   RTC
     }

//        RTC
void RTCust()
      { 
        HOUR=0;    //---------------------------------------------------
        MIN=0;     //       
        SEC=1;     //   :
        DOW=6;     //   00:00:01  
        DOM=1;     //   01.01.2012  (1  )
        MONTH=1;   //
        YEAR=2012; //
        DOY=1;     //---------------------------------------------------
      } 

//     RTC
void  RTCstart()
     {
//---------------   -----------------       
//       CCR = 0x1; //  RTC       CCR = 0b00000001 
//--------------------------------------------------------------------------

//-----      RTC-----------       
       CCR = 0x11; //  RTC      CCR = 0b00010001
//--------------------------------------------------------------------------
     }

//    RTC
void  RTCstop()
     {
       CCR = 0x0; //  RTC
     }

//         RTC
void RTCread_ind_date_time()
{
//        
//  
sec=CTIME0 & MASKSEC;
min=(CTIME0 & MASKMIN)>>8;
hour=(CTIME0 & MASKHOUR)>>16;
dow=(CTIME0 & MASKDOW)>>24;
dom=CTIME1 & MASKDOM;
month=(CTIME1 & MASKMONTH)>>8;
year=(CTIME1 & MASKYEAR)>>16;

//          RTC 
if (((CTC_bit.COUNTER & MASKCTC)>>14) == 1)  {sek_ritm=1;} 
else {sek_ritm=0;}

//     
//
hour10 = hour / 10;
hour1 = hour % 10;
lcd_pro_data(hour10, 0);
lcd_tek_data(hour1);
lcd_tek_data(':'); 

//     
//
min10 = min / 10;
min1 = min % 10;
lcd_tek_data(min10);
lcd_tek_data(min1);
//   
if (sek_ritm == TRUE) {lcd_tek_data(':');} 
else {lcd_tek_data(pusto);}  

//     
//
sek10 = sec / 10;
sek1 = sec % 10;
lcd_tek_data(sek10);
lcd_tek_data(sek1);

//       
/*switch(dow)
{
case 0:
  {
    lcd_pro_data(rus_P, 10); //
    lcd_tek_data('H');
  }
break;
case 1:
  {
    lcd_pro_data('B', 10); //
    lcd_tek_data('T');
  }
break;
case 2:
  {
    lcd_pro_data('C', 10); //
    lcd_tek_data('P');
  }
break;

case 3:
  {
    lcd_pro_data(rus_CH, 10); //
    lcd_tek_data('T');
  }
break;
case 4:
  {
    lcd_pro_data(rus_P, 10); //
    lcd_tek_data('T');
  }
break;
case 5:
  {
    lcd_pro_data('C', 10); //
    lcd_tek_data(rus_B);
  }
break;
case 6:
  {
    lcd_pro_data('B', 10); //
    lcd_tek_data('C');
  }
}*/

//       
r10 = dom / 10;
r1 = dom % 10;
lcd_pro_data(r10, 64);
lcd_tek_data(r1);
lcd_tek_data('.');

//      
r10 = month / 10;
r1 = month % 10;
lcd_pro_data(r10, 67);
lcd_tek_data(r1);
lcd_tek_data('.');

//      
r1000 = year / 1000;
year = year % 1000;
r100 = year / 100;
year = year % 100;
r10 = year / 10;
r1 = year % 10;
lcd_pro_data(r1000, 70);
lcd_tek_data(r100);
lcd_tek_data(r10);
lcd_tek_data(r1);
}

//    
void RTCset_min()
{
unsigned int min_tek;

RTCstop();  //   RTC
min_tek = MIN;
min_tek++;
if (min_tek > 59)  min_tek=0;
MIN = min_tek;
RTCstart();  //   RTC
}

//    
void RTCset_hour()
{
unsigned int hour_tek;

RTCstop();  //   RTC
hour_tek = HOUR;
hour_tek++;
if (hour_tek > 23)  hour_tek=0;
HOUR = hour_tek;
RTCstart();  //   RTC
}

//    
void RTCnull_sec()
{
RTCstop();  //   RTC
SEC = 0;
RTCstart();  //   RTC
}

//     
void RTCset_dow()
{
unsigned int dow_tek;

RTCstop();  //   RTC
dow_tek = DOW;
dow_tek++;
if (dow_tek > 6)  dow_tek=0;
DOW = dow_tek;
RTCstart();  //   RTC
}

//     
void RTCset_dom()
{
unsigned int dom_tek;

RTCstop();  //   RTC
dom_tek = DOM;
dom_tek++;
if (dom_tek > 31)  dom_tek=1;
DOM = dom_tek;
RTCstart();  //   RTC
}

//    
void RTCset_month()
{
unsigned int month_tek;

RTCstop();  //   RTC
month_tek = MONTH;
month_tek++;
if (month_tek > 12)  month_tek=1;
MONTH = month_tek;
RTCstart();  //   RTC
}

//    
void RTCset_year()
{
unsigned int year_tek;

RTCstop();  //   RTC
year_tek = YEAR;
year_tek++;
if (year_tek > MAX_YEAR)  year_tek = MIN_YEAR;
YEAR = year_tek;
RTCstart();  //   RTC
}
//-----------------------------------------------------------------------

