//------------------------------------------------------------------------
//   UART0, UART1
//-------------------------------------------------------------------------
#include "uart.h" //     

volatile unsigned char rx0_byte; //   UART0
volatile unsigned char rx1_byte; //   UART1

volatile unsigned int rx0_byte_f = 0; //    UART0
volatile unsigned int rx1_byte_f = 0; //    UART1

//   UART0
//(baudrate -     )
void UART0init(unsigned long baudrate)
  {
  PINSEL0_bit.P0_0 = 0x01;  // P0.0   TXD0 UART0
  PINSEL0_bit.P0_1 = 0x01;  // P0.1    RXD0 UART0	

  U0LCR_bit.DLAB = 1; //     UART0
  U0DLL = FOSC/(16*baudrate); //     
  U0DLM = ((FOSC/(16*baudrate)) >> 8); //     
  U0LCR_bit.DLAB = 0; //     UART0
  U0LCR_bit.WLS = 0x03; //  8 
  U0LCR_bit.SBS = 0;  //1  
  U0LCR_bit.PE    = 0; //  
  U0FCR_bit.FCRFE = 1; //  FIFO
  U0FCR_bit.RFR = 1; //   FIFO
  U0FCR_bit.TFR = 1; //   FIFO
    
  U0FCR_bit.RTLS = 0; // FIFO    1 
   
  U0IER_bit.RDAIE = 1; //      
  }

//    UART0
void UART0tx_byte(unsigned char tx_byte)
  {
  while (U0LSR_bit.THRE == 0); //    	
  U0THR = tx_byte; //    UART0 ( )
  }

//    UART0
unsigned char UART0rx_byte()
  {
   while (U0LSR_bit.RDR==0);
   rx0_byte = U0RBR; //   UART0,   
   return  rx0_byte;
  }


//   UART1
//(baudrate -     )
void UART1init(unsigned long baudrate)
  {
  PINSEL0_bit.P0_8 = 0x01;  // P0.8   TXD1 UART1
  PINSEL0_bit.P0_9 = 0x01;  // P0.9    RXD1 UART1	
  
  U1LCR_bit.DLAB = 1; //     UART1
  U1DLL = FOSC/(16*baudrate); //     
  U1DLM = ((FOSC/(16*baudrate)) >> 8); //     
  U1LCR_bit.DLAB = 0; //     UART1
  U1LCR_bit.WLS = 0x03; //  8 
  U1LCR_bit.SBS = 0;  //1  
  U1LCR_bit.PE    = 0; //  
  U1FCR_bit.FCRFE = 1; //  FIFO
  U1FCR_bit.RFR = 1; //   FIFO
  U1FCR_bit.TFR = 1; //   FIFO
    
  U1FCR_bit.RTLS = 0; // FIFO    1 
    
  U1IER_bit.RDAIE = 1; //      
  }


//    UART1
void UART1tx_byte(unsigned char tx_byte)
  {
  while (U1LSR_bit.THRE == 0); //    	
  U1THR = tx_byte; //    UART1 ( )
  }

//    UART1
unsigned char UART1rx_byte()
  {
   while (U1LSR_bit.RDR==0);
   rx1_byte = U1RBR; //   UART1,   
   return  rx1_byte;
  }
//--------------------------------------------------------------------














